
#    Note:  This is loaded into the namespace  MEISAPSR

# variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Cyan
    set Color2(1) #D4A017     ;# Orange Gold

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    variable OFF 1
    variable ON 0

    variable STOP 1
    variable GO 0

    variable RAMP 0

    variable Offset0 0.0kV  ;# threshold
    variable Offset1 0.0kV
    variable Offset2 0.0kV
    variable Offset3 0.0kV

    variable UNIT0 1
    variable UNIT1 0
    variable UNIT2 0
    variable UNIT3 0

    variable multiplier 60
    variable threshold 50000
    variable ramptime 10
    variable rampstep 1
    variable going 0
    variable steptime 10    ;#  move at 10 seconds/step
    variable final 0
    variable latest 0
    variable current 0


   proc  show_variables {} {
      variable Offset0
      variable Offset1
      variable Offset2
      variable Offset3

      InsertLog "Offsets $Offset0 $Offset1 $Offset2 $Offset3"


   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }

   proc do_Setting {reg vl} {InsertLog "Setting $reg $vl"
      variable Offset0
      variable Offset1
      variable Offset2
      variable Offset3

# note  -  sliders do not return units for analogue registers

      variable threshold
      variable final

       switch $reg {
           0   {set Offset0 [set vl]; variable threshold; set threshold $Offset0; WriteMEISRegister Analyser.Energy $Offset0}
           1   {set Offset1 [set vl]; variable final; set final $Offset1}
           2   {set Offset2 [set vl]}
           3   {set Offset3 [set vl]}
           default {}
       }
   }

   proc do_Power {vl} {    ;InsertLog "Power $vl"
      variable OFF
      variable ON

       switch $vl {
         0 {
            set OFF 1
            set ON 0
            WriteMEISRegister Analyser.Power 0
         }
         1 {
            set OFF 0
            set ON 1
            WriteVMERegister Analyser.Power 1
         }
         default {}
       }
   }

   proc do_Units {vl} {    ;InsertLog "Units $vl"
      variable UNIT0
      variable UNIT1
      variable UNIT2
      variable UNIT3

      variable multiplier

      set UNIT0 0; set UNIT1 0; set UNIT2 0; set UNIT3 0
      set UNIT$vl 1

      set multiplixer [lindex [list 1 60 3600 86400] $vl]
   }

   proc do_stopgo {vl} {    ;InsertLog "stopgo $vl"
      variable STOP
      variable GO

      variable going; set going $vl

       switch $vl {
         0 {
            set STOP 1
            set ON 0
         }
         1 {
            set STOP 0
            set GO 1
         }
         default {}
       }
   }

   proc do_Ramp {vl} {    ;InsertLog "Ramp $vl"
      variable RAMP
      variable ramptime

      set RAMP $vl
      set ramptime $vl

   }

   proc do_continue-ramping {} {


   }


    proc UpdateModule {} {
       variable Offset0
       variable Offset1

#    Offset0 => Threshold
#    Offset1 => End Energy
#    Offset2 => Set Energy
#    Offset3 => Voltage

#    Analyser.Energy    -r 0:0V,0xffff:416.667eV -i 0.0kV"

#    Analyser.Volts+    -r0:0V,0xfff:25kV"
#    Analyser.Volts-    -r0:0V,0xfff:25kV"
#    Analyser.Current+  -r0:0A,0xfff:1mA"
#    Analyser.Current-	-r0:0A,0xfff:1mA"

      set Offset0 [ReadMEISRegister Analyser.Energy]

       variable ON
       variable OFF

         if {[expr [ReadMEISRegister Analyser.Power] & 1] == 0} {set ON 0; set OFF 1} else {set ON 1; set OFF 0}
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {           

              set w [first [lindex $cgidata 1]]
              set n [second [lindex $cgidata 1]]
              set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   RANGE   -
                   TEXT    -
                   SETTING {do_Setting $n $vl}

                   POWER   {do_Power [second [lindex $cgidata 1]]}
                   UNIT    {do_Units [second [lindex $cgidata 1]]}
                   GO      {do_stopgo [second [lindex $cgidata 1]]}
                   RAMP    {do_Ramp [second [lindex $cgidata 1]]}


                   REDISPLAY {UpdateModule}
                   UPDATE    {UpdateModule}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateModule
     }
     UpdateModule

}   ;# end of if {$started == 0}




