
#    Note:  This is loaded into the namespace  MEISDPS

#variable started 0

#Detector.Current              : -a=0x00009000 -c6 -g=0 -q=u -u=A -d=0 -r=0x0000:0uA,0x0fff:1000uA
#Detector.Current.Request      : -a0x0000a000 -o0x00000002 -w16 -d16 -ud -mn -pwo -qu -tA -n0 -r0x0:0uA,0xfff:1000uA -i0uA
#Detector.Volts                : -a=0x00009000 -c5 -g=0 -q=  -u=V -d=0 -r=0x0000:0 V,0x0fff:3500 V
#Detector.Volts.Request        : -a0x0000a000 -o0x00000000 -w16 -d16 -ud -mn -pwo -q  -tV -n0 -r0x0:0 V,0xfff:3500 V -i0 V

#xvme560   0x9000
#msda12    0xa000


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable Offset0 2048
    variable Offset1 0
    variable Offset2 2048
    variable Offset3 0

    variable JS ""
    variable HelpTopic "undefined"


   proc  show_variables {} {
       variable Offset0
       variable Offset1
       variable Offset2
       variable Offset3

   set registerList [list  Detector.Current Detector.Current.Request Detector.Volts Detector.Volts.Request]

       InsertLog "Offsets $Offset0 $Offset1 $Offset2 $Offset3"

      foreach register $registerList {
         InsertLog "$register => [ReadMEISRegister $register]"
      }
   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }

   proc do_Setting {reg vl} {     ;InsertLog "Setting $reg $vl"
       variable Offset0
       variable Offset1
       variable Offset2
       variable Offset3

# note  -  sliders do not return units for analogue registers

#    Offset0 => Detector.Volts.Request
#    offset1 => Detector.Volts Monitor
#    Offset2 => Detector.Current.Request
#    Offset3 => Detector.Current Monitor

     switch $reg {
        rangeInput0     {set Offset0 $vl; WriteMEISRegister Detector.Volts.Request [set Offset0]V}
        rangeInput1     {set Offset1 $vl}
        rangeInput2     {set Offset2 $vl; WriteMEISRegister Detector.Current.Request [set Offset2]uA}
        rangeInput3     {set Offset3 $vl}
        default         {InsertLog "do_Setting: unexpected request $reg $vl"}
     }
   }

    proc UpdateModule {} {
       variable Offset0
       variable Offset1
       variable Offset2
       variable Offset3

#    Offset0 => Detector.Volts.Request
#    Offset1 => Detector.Volts
#    Offset2 => Detector.Current.Request
#    Offset3 => Detector.Current

         set Offset0 [stor [ReadMEISRegister Detector.Volts.Request]] 
         set Offset1 [stor [ReadMEISRegister Detector.Volts]]
         set Offset2 [stor [ReadMEISRegister Detector.Current.Request]]
         set Offset3 [stor [ReadMEISRegister Detector.Current]]

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set n [second [lindex $cgidata 1]]
              set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   RANGE   -
                   TEXT    -
                   SETTING {do_Setting $n $vl}

                   REDISPLAY {UpdateModule}
                   UPDATE    {UpdateModule}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateModule
     }
     UpdateModule

}   ;# end of if {$started == 0}




