
#    Note:  This is loaded into the namespace  MEISDPSR

# variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Cyan
    set Color2(1) #D4A017     ;# Orange Gold

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    variable OFF 1
    variable ON 0

    variable STOP 1
    variable GO 0

    variable RAMP 0

    variable Offset0 3500V  ;# threshold
    variable Offset1 3500V
    variable Offset2 3500V
    variable Offset3 3500V

    variable UNIT0 1
    variable UNIT1 0
    variable UNIT2 0
    variable UNIT3 0

    variable multiplier 60
    variable threshold 1200
    variable ramptime 10
    variable rampstep 1
    variable going 0
    variable steptime 10    ;#  move at 10 seconds/step
    variable final 0
    variable latest 0
    variable current 0

    variable rampafterid ""


   proc  show_variables {} {
      variable Offset0
      variable Offset1
      variable Offset2
      variable Offset3

      variable STOP
      variable GO

   set registerList [list  Detector.Volts Detector.Volts.Request]

       InsertLog "Offsets $Offset0 $Offset1 $Offset3 $Offset3"

      foreach register $registerList {
         InsertLog "$register => [ReadMEISRegister $register]"
      }

      InsertLog "STOP/GO  $STOP  $GO"
   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }

   proc do_Setting {reg vl} {        ;InsertLog "Setting $reg $vl"
      variable Offset0
      variable Offset1
      variable Offset2
      variable Offset3

#    Offset0 => threshold
#    Offset1 => final volts
#    Offset2 => Detector.Volts.Request
#    Offset3 => Detector.Volts

#Detector.Volts.Request      -r0:0V,0xfff:3.5kV  (3500V)   (MSDA12)
#Detector.Volts              -r0:0V,0xfff:3.5kV  (3500V)   (xvme560)

      variable threshold
      variable final

       switch $reg {
           rangeInput0   {set Offset0 $vl; variable threshold; set threshold $vl}
           rangeInput1   {}
           rangeInput2   {set Offset2 $vl; variable final; set final [set vl]V; WriteMEISRegister Detector.Volts.Request $final}
           rangeInput3   {}
           default       {InsertLog "do_Setting: unexpected request $reg $vl"}
       }
   }

   proc do_Units {vl} {    ;InsertLog "Units $vl"
      variable UNIT0
      variable UNIT1
      variable UNIT2
      variable UNIT3

      variable multiplier

      set UNIT0 0; set UNIT1 0; set UNIT2 0; set UNIT3 0
      set UNIT$vl 1

      set multiplixer [lindex [list 1 60 3600 86400] $vl]
   }

   proc do_Ramp {vl} {    ;InsertLog "Ramp $vl"
      variable RAMP
      variable ramptime

      set RAMP $vl
      set ramptime $vl

   }

    proc UpdateModule {} {
       variable Offset0
       variable Offset1
       variable Offset2
       variable Offset3

#    Offset0 => Threshold
#    Offset1 => End Energy
#    Offset2 => set Voltage
#    Offset3 => monitor

      set Offset3 [ReadMEISRegister Detector.Volts]
   }

proc continue-ramp {} {     ;variable going; puts "continue-ramp   $going"
    variable rampafterid 
    variable multiplier
    variable threshold
    variable ramptime
    variable rampstep
    variable going
    variable steptime
    variable final
    variable latest
    variable current

   if {$rampafterid != ""} then {catch {kill-after $rampafterid}}
   if {$going == 1} then {
      set rampafterid [after [expr $steptime * 1000] ::MEISDPSR::continue-ramp]
InsertLog "MCP Voltage Ramping in Progress"
      UpdateModule
InsertLog "continue latest: $latest"
      set new [expr $latest + $rampstep]
      if {$new > $final} then {set new $final}
InsertLog "continue new: $new"
      do_Setting rangeInput2 [expr round($new)]    ;#  set "Set Voltage"
      if {$new == $final} then {set going 0}
      set latest $new
InsertLog "continue current now: $current"
InsertLog "continue latest now: $latest"
InsertLog "continue done"
   } else {
      UpdateModule
puts "MCP Voltage Ramping Complete"
   }
}


proc do_stopgo {v} {            ;variable going; InsertLog "stopgo $v  $going"
    variable rampafterid 
    variable multiplier
    variable threshold
    variable ramptime
    variable rampstep
    variable going
    variable steptime
    variable final
    variable latest
    variable current

      variable STOP
      variable GO

       switch $v {
         0 {
            set STOP 1
            set GO 0
         }
         1 {
            set STOP 0
            set GO 1
         }
         default {}
       }

     if {$v==$going} then {return}

   if {$v == 1} then {    ;#   GO
      UpdateModule

      if {$final < $threshold || $final < $current} then {
InsertLog "$final $threshold $current"
         do_Setting rangeInput2 $final
         return
      }

      if {$current < $threshold} then {
         do_Setting rangeInput2 $threshold  ;#  set "Set Voltage"
InsertLog "current now: $current V"
         set pause $steptime
      } else {
         set pause 0
      }

      set latest [expr $current.0]
      set period [expr $ramptime * $multiplier]

InsertLog "total period: $period seconds"
      set steps [expr $period / $steptime]

      if {$steps < 1} then {set steps 1}
InsertLog "No. steps: $steps"
      set interval [expr $final - $latest]
InsertLog "interval: $interval V"
      set rampstep [expr $interval / $steps]
      if {$rampstep < 1} then {set rampstep 1}
InsertLog "ramp per step: $rampstep"

      set going 1
InsertLog "pause=$pause   $going"
      set rampafterid [after [expr $pause * 1000] ::MEISDPSR::continue-ramp]
   } else {
      set going 0
InsertLog "going=$going"
      continue-ramp
   }
}

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set n [second [lindex $cgidata 1]]
              set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   RANGE   -
                   TEXT    -
                   SETTING {do_Setting $n $vl}

                   UNIT    {do_Units $n}
                   GO      {do_stopgo $n}
                   RAMP    {do_Ramp $n}

                   REDISPLAY {UpdateModule}
                   UPDATE    {UpdateModule}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateModule
     }
     UpdateModule

}   ;# end of if {$started == 0}




