
#    Note:  This is loaded into the namespace  MEISG

#variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Cyan
    set Color2(1) #D4A017     ;# Orange Gold

    variable Offset0 0
    variable Offset1 0
    variable Offset2 0
    variable Offset3 0
    variable Offset4 0
    variable Offset5 0

    variable ROTA 0
    variable SPIN 0
    variable TILT 0
    variable HEIGHT 0
    variable ANAL 0
    variable ENER 0

    variable ON0 0
    variable EN0 0
    variable SCAN0 0
    variable REF0 1

    variable ON1 0
    variable EN1 0
    variable SCAN1 0
    variable REF1 1

    variable ON2 0
    variable EN2 0
    variable SCAN2 0
    variable REF2 1

    variable ON3 0
    variable EN3 0
    variable SCAN3 0
    variable REF3 1

    variable ON4 0
    variable EN4 0
    variable REF4 1

    variable ON5 0
    variable ON6 1
    variable SCAN4 1

    variable DEC1 1
    variable INC1 1
    variable DEC2 1
    variable INC2 1


set align(Rota)  0deg
set align(Spin)  152deg
set align(Tilt)  -1deg
set align(Height) 125mm
set align(Angle) 125deg

set transfer(Rota)  180.75deg
set transfer(Spin)  152.3deg
set transfer(Tilt)  -1deg
set transfer(Height)  125mm
set transfer(Angle) 90.5deg

variable estopping 1
variable scan_energy_active 0
variable scan_rot_active 0
variable aqafterid ""


   proc  show_variables {} {


   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }

   proc do_Button {vl} {    ;InsertLog "Button $vl"

       switch $vl {
         0 {variable ON0; set ON0 [expr ($ON0^1)&1]}
         1 {variable EN0; set EN0 [expr ($EN0^1)&1]; click-enable Goniometer.Rota.Enable [set EN0]}
         2 {variable SCAN0; set SCAN0 [expr ($SCAN0^1)&1]; click-scan Goniometer.Rota [set SCAN0]}
         3 {variable REF0; click-zero Goniometer.Rota.Zero [set REF0]}
         4 {variable ON1; set ON1 [expr ($ON1^1)&1]}
         5 {variable EN1; set EN1 [expr ($EN1^1)&1]; click-enable Goniometer.Spin.Enable [set EN1]}
         6 {variable SCAN1; set SCAN1 [expr ($SCAN1^1)&1]; click-scan Goniometer.Spin [set SCAN1]}
         7 {variable REF1; click-zero Goniometer.Spin.Zero [set REF1]}
         8 {variable ON2; set ON2 [expr ($O2^1)&1]}
         9 {variable EN2; set EN2 [expr ($EN2^1)&1]; click-enable Goniometer.Tilt.Enable [set EN2]}
         10 {variable SCAN2; set SCAN2 [expr ($SCAN2^1)&1]; click-scan Goniometer.Tilt [set SCAN2]}
         11 {variable REF2; click-zero Goniometer.Tilt.Zero [set REF2]}
         12 {variable ON3; set ON3 [expr ($ON3^1)&1]}
         13 {variable EN3; set EN3 [expr ($EN3^1)&1]; click-enable Goniometer.Height.Enable [set EN3]}
         14 {variable SCAN3; set SCAN3 [expr ($SCAN4^1)&1]; click-scan Goniometer.Height [set SCAN3]}
         15 {variable REF3; click-zero Goniometer.Height.Zero [set REF3]}
         16 {variable ON4; set ON4 [expr ($ON4^1)&1]}
         17 {variable EN4; set EN4 [expr ($EN4^1)&1]; click-enable Analyser.Angle.Enable [set EN4]}
         18 {variable ANAL; incr ANAL -27; click-incr Analyser.Angle.Request -27 deg}
         19 {variable ANAL; incr ANAL 27; click-incr Analyser.Angle.Request +27 deg}
         20 {variable REF4; click-zero Analyser.Angle.Zero [set REF4]}

         21 {variable ON5; set ON5 [expr ($ON5^1)&1]; variable ON6; set ON6 [expr ($ON5^1)&1]}
         22 {variable ON6; set ON6 [expr ($ON6^1)&1]; variable ON5; set ON5 [expr ($ON6^1)&1]}
         23 {variable ENER; incr ENER -1; click-incr Analyser.Energy -1 keV}
         24 {variable ENER; incr ENER 1; click-incr Analyser.Energy +1 keV}
         25 {variable SCAN4; click-scan-energy $SCAN4}

         default {}
       }
   }

   proc click-enable {reg vl} {

#    Buttons 1; 5; 9; 13; 17

       WriteNETRegister $reg $vl
       if {$vl ==1} {InsertLog "Stepper Motor now enabled"}
   }

   proc click-zero {reg vl} {

#    Buttons 3;  7;  11;  15;  20

       WriteNETRegister $reg $vl
       if {$vl ==1} {InsertLog "Zeroing Stepper Motor..."}
   }

   proc click-incr {reg vl a} {   ;# decr when vl < 0

#    Buttons 18;  19;  23;  24

      set value [expr [ReadVMERegister $reg] + $vl]
      WriteVMERegister $reg $value
      InsertLog "Setting analyser to $value $a"
   }

   proc click-scan {reg vl a} {

      WriteNETRegister $reg $vl



   }
      

   proc do_Req {reg vl} {    ;InsertLog "Req $reg $vl"

#    0 => ROTA (deg)
#    1 => SPIN (deg)
#    2 => TILT (deg)
#    3 => HEIGHT  (mm)
#    4 => ANAL (deg)
#    5 => ENER (keV)

       switch $reg {
         0 {variable ROTA; set ROTA $vl; WriteNETRegister Goniometer.Rota.Request [set ROTA]}
         1 {variable SPIN; set SPIN $vl; WriteNETRegister Goniometer.Spin.Request [set SPIN]}
         2 {variable TILT; set TILT $vl; WriteNETRegister Goniometer.Tilt.Request [set TILT]}
         3 {variable HEIGHT; set HEIGHT $vl; WriteNETRegister Goniometer.Height.Request [set HEIGHT]}
         4 {variable ANAL; set ANAL $vl; WriteNETRegister Analyser.Angle.Request [set ANAL]}
         5 {variable ENER; set ENER $vl; WriteVMERegister Analyser.Energy [set ENER]}
         default {}
       }
   }

   proc UpdateModule {} {
    
       variable EN0; set EN0 [scan-int [ReadNETRegister Goniometer.Rota.Enable]]
       variable EN1; set EN1 [scan-int [ReadNETRegister Goniometer.Spin.Enable]]
       variable EN2; set EN2 [scan-int [ReadNETRegister Goniometer.Tilt.Enable]]
       variable EN3; set EN3 [scan-int [ReadNETRegister Goniometer.Height.Enable]]
       variable EN4; set EN4 [scan-int [ReadNETRegister Goniometer.Angle.Enable]]

       variable SCAN0; set SCAN0 [scan-int [ReadNETRegister Goniometer.Rota]]
       variable SCAN1; set SCAN1 [scan-int [ReadNETRegister Goniometer.Spin]]
       variable SCAN2; set SCAN2 [scan-int [ReadNETRegister Goniometer.Tilt]]
       variable SCAN3; set SCAN3 [scan-int [ReadNETRegister Goniometer.Height]]

       variable ROTA; set ROTA [scan-int [ReadNETRegister Goniometer.Rota.Request]]
       variable SPIN; set SPIN [scan-int [ReadNETRegister Goniometer.Spin.Request]]
       variable TILT; set TILT [scan-int [ReadNETRegister Goniometer.Tilt.Request]]
       variable HEIGHT; set HEIGHT [scan-int [ReadNETRegister Goniometer.Height.Request]]
       variable ANAL; set ANAL [scan-int [ReadNETRegister Analyser.Angle.Request]]

       variable ENER; set ENER [ReadVMERegister Analyser.Energy]

   }

#proc UpdateModule {} {}

 
   proc click-scan-energy v {
	variable estopping 
        variable scan_energy_active 
        variable scan_rot_active

	if {$v == 1} then {
		if {$scan_rot_active == 1} then {
			InsertLog "Cannot start Energy Scan.\n2D Rotation Scan already running."
			return
		}
		set scan_energy_active 1
		set estopping 0
		if {![inform sys click-acquisition 1]} then {
			scan-energy-refresh -1
			set estopping 1
			return
		}
	} else {
		set estopping 1
	}
	scan-energy-refresh $v
   }

   proc scan-energy-refresh {v} {
	variable estopping 
        variable scan_energy_active
        variable aqafterid

	if {$aqafterid!=""} then {catch {kill-after $aqafterid}}
	if {!$scan_energy_active == 1} then {return}

	if {$v==-1} then {
		InsertLog "Data Acquisition Stopped"
		variable SCAN4; set SCAN4 0
		set estopping 1
		set scan_energy_active 0
		return
	}
	if {!$v} then {
		InsertLog "Data Acquisition Stopping"
		variable SCAN4; set SCAN4 1
	}
	set going [send sys inquire going]
	if {$going} then {
		set aqafterid [after 5000 scan-energy-refresh 1]
		if {!$estopping} {
			set-footer "Data Acquisition in Progress"
		}
		:modify SCAN-ENERGY :value 1
	} else {
		set-footer "Data Acquisition Complete"
		set aqsaved [send sys inquire aqsaved]
		if {!$aqsaved} then {
			set aqafterid [after 5000 scan-energy-refresh 1]
			set-footer "Data Being Saved" 
		} else {
			:modify SCAN-ENERGY :inactive F
			if {!$estopping} then {
				if {[read-reg ERDA.Enable] == 1} {
					inform erda set-new-tac-bases
				}
				if {$auto_height} then {
					if {[move-height] == "MoveHeightDone"} {return}
				}
				click-on DEC-ENERGY ""
				click-scan-energy 1
			} else {
				if {[is-started sd]} then {send sd refresh-once; send sd stop-refresh}
				set scan_energy_active 0
				:modify SCAN-ENERGY :value 0
				stop-height-scan
                        }
		}
	}
   }

   proc do_Setting {reg vl} {     ;InsertLog "These settings are read only"
      variable Offset0
      variable Offset1
      variable Offset2
      variable Offset3
      variable Offset4
      variable Offset5

       switch $reg {
        rangeInput0     {set Offset0 $vl}
        rangeInput1     {set Offset1 $vl}
        rangeInput2     {set Offset2 $vl}
        rangeInput3     {set Offset3 $vl}
        rangeInput4     {set Offset4 $vl}
        rangeInput5     {set Offset5 $vl}
        default {}
     }
   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set n [second [lindex $cgidata 1]]
              set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   RANGE   -
                   TEXT    -
                   SETTING {do_Setting $n $vl}

                   BUTTON   {do_Button [second [lindex $cgidata 1]]}
                   REQ      {do_Req [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}

                   REDISPLAY {UpdateModule}
                   UPDATE    {UpdateModule}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateModule
     }
     UpdateModule

}   ;# end of if {$started == 0}




