
#    Note:  This is loaded into the namespace  SaveRestore

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

     do_click

#     LoadOptions
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable filter "undefined"

#    set ::Settings(0x0006dead) 0
#    set ::Settings(VME.settings) undefined


   proc LoadOptions {} {

          set Project $::DataAcquisition::PROJECT
          set DBRootName [set ::[set Project]::DBRootName]
          set DBNodeBase [set ::[set Project]::DBNodeBase]
          set ::[set Project]::DBNodeName "Settings"

          DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

      catch {unset ::Options}

      foreach item [split [DBGetValue Index] &&] {
         if {$item == ""} {continue}
         if {$item == "Index"} {continue}
         if {$item == "Error!"} {continue}
         set vl [DBGetValue $item]
         if {$vl != "Error!"} {set ::Options($item) $vl}
      }

#      InsertLog "Options restored from $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]"

   }

   proc SaveOptions {} {

          set Project $::DataAcquisition::PROJECT
          set DBRootName [set ::[set Project]::DBRootName]
          set DBNodeBase [set ::[set Project]::DBNodeBase]
          set ::[set Project]::DBNodeName "Settings"

          DBCreateNode $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]

      set OptionList ""
      foreach item [array names ::Options] {
         if {$item == ""} {continue}
         if {$item == "Index"} {continue}
         if {$item == "Error!"} {continue}
         if {[string length $OptionList] > 0} {append OptionList "&&"}
         append OptionList "$item"
         DBSetValue "$item" [first [set ::Options($item)]]
      }
      DBSetValue Index $OptionList

#      InsertLog "Options saved to $DBRootName/$DBNodeBase/[set ::[set Project]::DBNodeName]"

   }

   proc  show_variables {} {
      variable filter

      InsertLog  "filter = $filter"
      set Project $::DataAcquisition::PROJECT
      InsertLog "Project = $Project"
      InsertLog "DBRootName = [set ::[set Project]::DBRootName]"
      InsertLog "DBNodeBase = [set ::[set Project]::DBNodeBase]"

      InsertLog "%%%%%%[array names ::Settings]"

      InsertLog ">>>>>>[array names ::Filtered]"

   }

   proc do_redisplay {} {}

   proc do_setOpt {index vl} {

    set i 0
    foreach item [lsort [array names ::Filtered]] {
       if {$i == $index} {set ::Options($item) $vl; break}
       incr i
    }

       SaveOptions
   }

   proc do_newOpt {item} {

       set ::Options($item) "undefined"

       SaveOptions
   }

   proc do_delOpt {index} {

    set i 0
    foreach item [lsort [array names ::Filtered]] {
       if {$i == $index} {unset ::Options($item); break}
       incr i
    }

       SaveOptions
   }

   proc do_filter {index} {
      variable filter
      set filter $index
   }

   proc ApplyFilter {} {
     variable filter

     catch {unset ::Filtered}

     foreach item [lsort [array names ::Options]] {
        if {$item == "Index"} {continue}
        if {$item == "Error!"} {continue}
        if {[string match undefined $filter] || [string match *[set filter]* $item]} {
             set ::Filtered($item) [set ::Options($item)]
        }
     }

   }

      proc do_Save {} {

           SaveOptions

           InsertLog "Settings saved"

    }

      proc do_Restore {} {

           LoadOptions

           InsertLog "Settings restored"
    }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   RESTORE  {do_Restore}
                   SAVE     {do_Save}

                   OPTS     {do_setOpt $vl [third [lindex $cgidata 1]]}
                   NEWOPT   {do_newOpt $vl}
                   DELOPT   {do_delOpt $vl}
                   FILTER   {do_filter $vl}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
        ApplyFilter
     }

#    LoadOptions
#    ApplyFilter


}   ;# end of if {$started == 0}




